﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class Window : Form
    {
        private Color initColor = Color.Yellow;

        public Window()
        {
            InitializeComponent();
            pictureBox.Image = 
                new Bitmap (pictureBox.Width, pictureBox.Height);

            Graphics g = Graphics.FromImage (pictureBox.Image);
            Brush b = new SolidBrush (initColor);
            g.FillRectangle(b, 0, 0, 
                        pictureBox.Width, pictureBox.Height); 
        }

        private void testMenu_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage(pictureBox.Image);
            Pen p = new Pen (Color.FromArgb(100, 200, 0));
            p.Width = 3;
            g.DrawLine(p, 10, 10, 100, 100);
            pictureBox.Invalidate ();
        }

        private void quitItem_Click(object sender, EventArgs e)
        {
            Close ();
        }

        int X0, Y0;
        bool stisk = false;
        Bitmap save;

        private void pictureBox_MouseDown(object sender, 
                                          MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisk = true;
            save = new Bitmap (pictureBox.Image);
        }

        private void paint (MouseEventArgs e, Pen p)
        {
            Graphics g = Graphics.FromImage(pictureBox.Image);
            g.DrawImage(save, 0, 0);

            if (e.Button == MouseButtons.Left)
            {
                g.DrawLine(p, X0, Y0, e.X, e.Y);
            }
            else if (e.Button == MouseButtons.Middle)
            {
                g.DrawEllipse(p, X0, Y0, e.X - X0, e.Y - Y0);
            }
            else if (e.Button == MouseButtons.Right)
            {
                /*
                int X = X0;
                int Y = Y0;
                int W = e.X - X0;
                int H = e.Y - Y0;
                if (W < 0) { X += W; W = -W; }
                if (H < 0) { Y += H; H = -H; }
                g.DrawRectangle(p, X, Y, W, H);
                */

                g.DrawRectangle (p, Math.Min (X0,e.X),
                                    Math.Min (Y0,e.Y),
                                    Math.Abs (X0-e.X),
                                    Math.Abs (Y0-e.Y));

            }

            pictureBox.Invalidate();
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
                paint (e, pen);
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
               paint (e, pen);
               stisk = false;
            }
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Bitmap t = 
                new Bitmap (
                  Math.Max(pictureBox.Width, pictureBox.Image.Width),
                  Math.Max(pictureBox.Height, pictureBox.Image.Height)
                  );
            Graphics g = Graphics.FromImage (t);
            Brush b = new SolidBrush(initColor);
            g.FillRectangle(b, 0, 0, t.Width, t.Height);
            g.DrawImage(pictureBox.Image, 0, 0);
            pictureBox.Image = t;
        }

        Pen pen = new Pen(Color.Orange);
        Brush brush = new SolidBrush(Color.Magenta);

        private void colorPanel1_MouseDown(object sender, MouseEventArgs e)
        {
            Color color = (sender as Panel).BackColor;

            if (e.Button == MouseButtons.Left)
                pen = new Pen(color);
            if (e.Button == MouseButtons.Right)
                brush = new SolidBrush (color);
        }

        private void panel2_Paint(object sender, PaintEventArgs e)
        {

        }

    }
}
